#################################
### VoiceFservs.tcl           ###
### Version 1.2               ###
### By Wcc                    ###
### wcc@techmonkeys.org       ###
### http://dawg.oc255.net:81/ ###
### EFnet #|DAWG|Tcl          ###
#################################

############################################################################
### Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

###########################################################################
## This script voices users who run an Fserv/FTP/TDCC ad in the channel. ##
###########################################################################

##############
## COMMANDS ##
##############################################
## DCC ## .chanset <channel> +/-voicefservs ##
######### Enables or disables Fserv auto-   ##
######### voice for a channel.              ##
##############################################

######################################
## Just load the script and rehash. ##
######################################

####################
# Code begins here #
####################

if {![string match 1.6.* $version]} { putlog "\002VOICEFSERVS:\002 \002WARNING:\002 This script is intended to run on eggdrop 1.6.x or later." }
if {[info tclversion] < 8.2} { putlog "\002VOICEFSERVS:\002 \002WARNING:\002 This script is intended to run on Tcl Version 8.2 or later." }

setudef flag voicefservs
bind pubm - * voicefservs_parse

proc voicefservs_rcodes {text} {
	regsub -all -- {\002|\037|\026|\003([0-9][0-9]?(,[0-9][0-9]?)?)?} $text "" text
	return $text
}
proc voicefservs_parse {nick uhost hand chan text} {
	if {![botisop $chan] || [isop $nick $chan] || [isvoice $nick $chan]} { return }
	set text [voicefservs_rcodes [string tolower $text]]
	if {([regexp file $text] && [regexp server $text] && [regexp online $text] && [regexp trigger $text] && [regexp send|cps $text]) || ([regexp ftp $text] && [regexp users|add $text] && [regexp l*p|port $text]) || ([string match tdcc $text] && [regexp trigger $text] && [regexp sends $text] && [regexp queue $text])} {
		if {[lsearch -exact [channel info $chan] +voicefservs] != -1} { pushmode $chan +v $nick }
	}
}
putlog "\002VOICEFSERVS:\002 VoiceFservs.tcl Version 1.2 by Wcc is loaded."